Index: /NEMO/branches/2020/temporary_r4_trunk/src/TOP/PISCES/P4Z/p4zfechem.F90
===================================================================
--- /NEMO/branches/2020/temporary_r4_trunk/src/TOP/PISCES/P4Z/p4zfechem.F90	(revision 13468)
+++ /NEMO/branches/2020/temporary_r4_trunk/src/TOP/PISCES/P4Z/p4zfechem.F90	(revision 13469)
@@ -89,86 +89,78 @@
       ! Chemistry is supposed to be fast enough to be at equilibrium
       ! ------------------------------------------------------------
-      DO jk = 1, jpkm1
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-               zTL1(ji,jj,jk)  = ztotlig(ji,jj,jk)
-               zkeq            = fekeq(ji,jj,jk)
-               zfesatur        = zTL1(ji,jj,jk) * 1E-9
-               ztfe            = trb(ji,jj,jk,jpfer) 
-               ! Fe' is the root of a 2nd order polynom
-               zFe3 (ji,jj,jk) = ( -( 1. + zfesatur * zkeq - zkeq * ztfe )               &
-                  &              + SQRT( ( 1. + zfesatur * zkeq - zkeq * ztfe )**2       &
-                  &              + 4. * ztfe * zkeq) ) / ( 2. * zkeq )
-               zFe3 (ji,jj,jk) = zFe3(ji,jj,jk) * 1E9
-               zFeL1(ji,jj,jk) = MAX( 0., trb(ji,jj,jk,jpfer) * 1E9 - zFe3(ji,jj,jk) )
-           END DO
-         END DO
-      END DO
+      DO_3D_11_11( 1, jpkm1 )
+         zTL1(ji,jj,jk)  = ztotlig(ji,jj,jk)
+         zkeq            = fekeq(ji,jj,jk)
+         zfesatur        = zTL1(ji,jj,jk) * 1E-9
+         ztfe            = trb(ji,jj,jk,jpfer) 
+         ! Fe' is the root of a 2nd order polynom
+         zFe3 (ji,jj,jk) = ( -( 1. + zfesatur * zkeq - zkeq * ztfe )               &
+            &              + SQRT( ( 1. + zfesatur * zkeq - zkeq * ztfe )**2       &
+            &              + 4. * ztfe * zkeq) ) / ( 2. * zkeq )
+         zFe3 (ji,jj,jk) = zFe3(ji,jj,jk) * 1E9
+         zFeL1(ji,jj,jk) = MAX( 0., trb(ji,jj,jk,jpfer) * 1E9 - zFe3(ji,jj,jk) )
+      END_3D
          !
 
       zdust = 0.         ! if no dust available
-      DO jk = 1, jpkm1
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-               ! Scavenging rate of iron. This scavenging rate depends on the load of particles of sea water. 
-               ! This parameterization assumes a simple second order kinetics (k[Particles][Fe]).
-               ! Scavenging onto dust is also included as evidenced from the DUNE experiments.
-               ! --------------------------------------------------------------------------------------
-               zhplus  = max( rtrn, hi(ji,jj,jk) )
-               fe3sol  = fesol(ji,jj,jk,1) * ( zhplus**3 + fesol(ji,jj,jk,2) * zhplus**2  &
-               &         + fesol(ji,jj,jk,3) * zhplus + fesol(ji,jj,jk,4)     &
-               &         + fesol(ji,jj,jk,5) / zhplus )
-               !
-               zfeequi = zFe3(ji,jj,jk) * 1E-9
-               zfecoll = 0.5 * zFeL1(ji,jj,jk) * 1E-9
-               ! precipitation of Fe3+, creation of nanoparticles
-               precip(ji,jj,jk) = MAX( 0., ( zFe3(ji,jj,jk) * 1E-9 - fe3sol ) ) * kfep * xstep
-               !
-               ztrc   = ( trb(ji,jj,jk,jppoc) + trb(ji,jj,jk,jpgoc) + trb(ji,jj,jk,jpcal) + trb(ji,jj,jk,jpgsi) ) * 1.e6 
-               IF( ln_dust )  zdust  = dust(ji,jj) / ( wdust / rday ) * tmask(ji,jj,jk) &
-               &  * EXP( -gdept_n(ji,jj,jk) / 540. )
-               IF (ln_ligand) THEN
-                  zxlam  = xlam1 * MAX( 1.E-3, EXP(-2 * etot(ji,jj,jk) / 10. ) * (1. - EXP(-2 * trb(ji,jj,jk,jpoxy) / 100.E-6 ) ))
-               ELSE
-                  zxlam  = xlam1 * 1.0
-               ENDIF
-               zlam1b = 3.e-5 + xlamdust * zdust + zxlam * ztrc
-               zscave = zfeequi * zlam1b * xstep
-
-               ! Compute the different ratios for scavenging of iron
-               ! to later allocate scavenged iron to the different organic pools
-               ! ---------------------------------------------------------
-               zdenom1 = zxlam * trb(ji,jj,jk,jppoc) / zlam1b
-               zdenom2 = zxlam * trb(ji,jj,jk,jpgoc) / zlam1b
-
-               !  Increased scavenging for very high iron concentrations found near the coasts 
-               !  due to increased lithogenic particles and let say it is unknown processes (precipitation, ...)
-               !  -----------------------------------------------------------
-               zlamfac = MAX( 0.e0, ( gphit(ji,jj) + 55.) / 30. )
-               zlamfac = MIN( 1.  , zlamfac )
-               zdep    = MIN( 1., 1000. / gdept_n(ji,jj,jk) )
-               zcoag   = 1E-4 * ( 1. - zlamfac ) * zdep * xstep * trb(ji,jj,jk,jpfer)
-
-               !  Compute the coagulation of colloidal iron. This parameterization 
-               !  could be thought as an equivalent of colloidal pumping.
-               !  It requires certainly some more work as it is very poorly constrained.
-               !  ----------------------------------------------------------------
-               zlam1a   = ( 0.369  * 0.3 * trb(ji,jj,jk,jpdoc) + 102.4  * trb(ji,jj,jk,jppoc) ) * xdiss(ji,jj,jk)    &
-                   &      + ( 114.   * 0.3 * trb(ji,jj,jk,jpdoc) )
-               zaggdfea = zlam1a * xstep * zfecoll
-               !
-               zlam1b   = 3.53E3 * trb(ji,jj,jk,jpgoc) * xdiss(ji,jj,jk)
-               zaggdfeb = zlam1b * xstep * zfecoll
-               !
-               tra(ji,jj,jk,jpfer) = tra(ji,jj,jk,jpfer) - zscave - zaggdfea - zaggdfeb &
-               &                     - zcoag - precip(ji,jj,jk)
-               tra(ji,jj,jk,jpsfe) = tra(ji,jj,jk,jpsfe) + zscave * zdenom1 + zaggdfea
-               tra(ji,jj,jk,jpbfe) = tra(ji,jj,jk,jpbfe) + zscave * zdenom2 + zaggdfeb
-               zscav3d(ji,jj,jk)   = zscave
-               zcoll3d(ji,jj,jk)   = zaggdfea + zaggdfeb
-               !
-            END DO
-         END DO
-      END DO
+      DO_3D_11_11( 1, jpkm1 )
+         ! Scavenging rate of iron. This scavenging rate depends on the load of particles of sea water. 
+         ! This parameterization assumes a simple second order kinetics (k[Particles][Fe]).
+         ! Scavenging onto dust is also included as evidenced from the DUNE experiments.
+         ! --------------------------------------------------------------------------------------
+         zhplus  = max( rtrn, hi(ji,jj,jk) )
+         fe3sol  = fesol(ji,jj,jk,1) * ( zhplus**3 + fesol(ji,jj,jk,2) * zhplus**2  &
+         &         + fesol(ji,jj,jk,3) * zhplus + fesol(ji,jj,jk,4)     &
+         &         + fesol(ji,jj,jk,5) / zhplus )
+         !
+         zfeequi = zFe3(ji,jj,jk) * 1E-9
+         zfecoll = 0.5 * zFeL1(ji,jj,jk) * 1E-9
+         ! precipitation of Fe3+, creation of nanoparticles
+         precip(ji,jj,jk) = MAX( 0., ( zFe3(ji,jj,jk) * 1E-9 - fe3sol ) ) * kfep * xstep
+         !
+         ztrc   = ( trb(ji,jj,jk,jppoc) + trb(ji,jj,jk,jpgoc) + trb(ji,jj,jk,jpcal) + trb(ji,jj,jk,jpgsi) ) * 1.e6 
+         IF( ln_dust )  zdust  = dust(ji,jj) / ( wdust / rday ) * tmask(ji,jj,jk) &
+         &  * EXP( -gdept_n(ji,jj,jk) / 540. )
+         IF (ln_ligand) THEN
+            zxlam  = xlam1 * MAX( 1.E-3, EXP(-2 * etot(ji,jj,jk) / 10. ) * (1. - EXP(-2 * trb(ji,jj,jk,jpoxy) / 100.E-6 ) ))
+         ELSE
+            zxlam  = xlam1 * 1.0
+         ENDIF
+         zlam1b = 3.e-5 + xlamdust * zdust + zxlam * ztrc
+         zscave = zfeequi * zlam1b * xstep
+
+         ! Compute the different ratios for scavenging of iron
+         ! to later allocate scavenged iron to the different organic pools
+         ! ---------------------------------------------------------
+         zdenom1 = zxlam * trb(ji,jj,jk,jppoc) / zlam1b
+         zdenom2 = zxlam * trb(ji,jj,jk,jpgoc) / zlam1b
+
+         !  Increased scavenging for very high iron concentrations found near the coasts 
+         !  due to increased lithogenic particles and let say it is unknown processes (precipitation, ...)
+         !  -----------------------------------------------------------
+         zlamfac = MAX( 0.e0, ( gphit(ji,jj) + 55.) / 30. )
+         zlamfac = MIN( 1.  , zlamfac )
+         zdep    = MIN( 1., 1000. / gdept_n(ji,jj,jk) )
+         zcoag   = 1E-4 * ( 1. - zlamfac ) * zdep * xstep * trb(ji,jj,jk,jpfer)
+
+         !  Compute the coagulation of colloidal iron. This parameterization 
+         !  could be thought as an equivalent of colloidal pumping.
+         !  It requires certainly some more work as it is very poorly constrained.
+         !  ----------------------------------------------------------------
+         zlam1a   = ( 0.369  * 0.3 * trb(ji,jj,jk,jpdoc) + 102.4  * trb(ji,jj,jk,jppoc) ) * xdiss(ji,jj,jk)    &
+             &      + ( 114.   * 0.3 * trb(ji,jj,jk,jpdoc) )
+         zaggdfea = zlam1a * xstep * zfecoll
+         !
+         zlam1b   = 3.53E3 * trb(ji,jj,jk,jpgoc) * xdiss(ji,jj,jk)
+         zaggdfeb = zlam1b * xstep * zfecoll
+         !
+         tra(ji,jj,jk,jpfer) = tra(ji,jj,jk,jpfer) - zscave - zaggdfea - zaggdfeb &
+         &                     - zcoag - precip(ji,jj,jk)
+         tra(ji,jj,jk,jpsfe) = tra(ji,jj,jk,jpsfe) + zscave * zdenom1 + zaggdfea
+         tra(ji,jj,jk,jpbfe) = tra(ji,jj,jk,jpbfe) + zscave * zdenom2 + zaggdfeb
+         zscav3d(ji,jj,jk)   = zscave
+         zcoll3d(ji,jj,jk)   = zaggdfea + zaggdfeb
+         !
+      END_3D
       !
       !  Define the bioavailable fraction of iron
@@ -178,19 +170,15 @@
       IF( ln_ligand ) THEN
          !
-         DO jk = 1, jpkm1
-            DO jj = 1, jpj
-               DO ji = 1, jpi
-                  zlam1a   = ( 0.369  * 0.3 * trb(ji,jj,jk,jpdoc) + 102.4  * trb(ji,jj,jk,jppoc) ) * xdiss(ji,jj,jk)    &
-                      &    + ( 114.   * 0.3 * trb(ji,jj,jk,jpdoc) )
-                  !
-                  zlam1b   = 3.53E3 *   trb(ji,jj,jk,jpgoc) * xdiss(ji,jj,jk)
-                  zligco   = 0.5 * trn(ji,jj,jk,jplgw)
-                  zaggliga = zlam1a * xstep * zligco
-                  zaggligb = zlam1b * xstep * zligco
-                  tra(ji,jj,jk,jplgw) = tra(ji,jj,jk,jplgw) - zaggliga - zaggligb
-                  zlcoll3d(ji,jj,jk)  = zaggliga + zaggligb
-               END DO
-            END DO
-         END DO
+         DO_3D_11_11( 1, jpkm1 )
+            zlam1a   = ( 0.369  * 0.3 * trb(ji,jj,jk,jpdoc) + 102.4  * trb(ji,jj,jk,jppoc) ) * xdiss(ji,jj,jk)    &
+                &    + ( 114.   * 0.3 * trb(ji,jj,jk,jpdoc) )
+            !
+            zlam1b   = 3.53E3 *   trb(ji,jj,jk,jpgoc) * xdiss(ji,jj,jk)
+            zligco   = 0.5 * trn(ji,jj,jk,jplgw)
+            zaggliga = zlam1a * xstep * zligco
+            zaggligb = zlam1b * xstep * zligco
+            tra(ji,jj,jk,jplgw) = tra(ji,jj,jk,jplgw) - zaggliga - zaggligb
+            zlcoll3d(ji,jj,jk)  = zaggliga + zaggligb
+         END_3D
          !
          plig(:,:,:) =  MAX( 0., ( ( zFeL1(:,:,:) * 1E-9 ) / ( trb(:,:,:,jpfer) +rtrn ) ) )
Index: /NEMO/branches/2020/temporary_r4_trunk/src/TOP/PISCES/P4Z/p4zsbc.F90
===================================================================
--- /NEMO/branches/2020/temporary_r4_trunk/src/TOP/PISCES/P4Z/p4zsbc.F90	(revision 13468)
+++ /NEMO/branches/2020/temporary_r4_trunk/src/TOP/PISCES/P4Z/p4zsbc.F90	(revision 13469)
@@ -126,43 +126,39 @@
             CALL fld_read( kt, 1, sf_river )
             IF( ln_p4z ) THEN
-               DO jj = 1, jpj
-                  DO ji = 1, jpi
-                     zcoef = ryyss * e1e2t(ji,jj) * h_rnf(ji,jj) 
-                     rivalk(ji,jj) =   sf_river(jr_dic)%fnow(ji,jj,1)  &
-                        &              * 1.E3        / ( 12. * zcoef + rtrn )
-                     rivdic(ji,jj) =   sf_river(jr_dic)%fnow(ji,jj,1)  &
-                        &              * 1.E3         / ( 12. * zcoef + rtrn )
-                     rivdin(ji,jj) =   sf_river(jr_din)%fnow(ji,jj,1)  &
-                        &              * 1.E3 / rno3 / ( 14. * zcoef + rtrn )
-                     rivdip(ji,jj) =   sf_river(jr_dip)%fnow(ji,jj,1)  &
-                        &              * 1.E3 / po4r / ( 31. * zcoef + rtrn )
-                     rivdsi(ji,jj) =   sf_river(jr_dsi)%fnow(ji,jj,1)  &
-                        &              * 1.E3        / ( 28.1 * zcoef + rtrn )
-                     rivdoc(ji,jj) =   sf_river(jr_doc)%fnow(ji,jj,1)  &
-                        &              * 1.E3        / ( 12. * zcoef + rtrn ) 
-                  END DO
-               END DO
+               DO_2D_11_11
+                  zcoef = ryyss * e1e2t(ji,jj) * h_rnf(ji,jj) 
+                  rivalk(ji,jj) =   sf_river(jr_dic)%fnow(ji,jj,1)  &
+                     &              * 1.E3        / ( 12. * zcoef + rtrn )
+                  rivdic(ji,jj) =   sf_river(jr_dic)%fnow(ji,jj,1)  &
+                     &              * 1.E3         / ( 12. * zcoef + rtrn )
+                  rivdin(ji,jj) =   sf_river(jr_din)%fnow(ji,jj,1)  &
+                     &              * 1.E3 / rno3 / ( 14. * zcoef + rtrn )
+                  rivdip(ji,jj) =   sf_river(jr_dip)%fnow(ji,jj,1)  &
+                     &              * 1.E3 / po4r / ( 31. * zcoef + rtrn )
+                  rivdsi(ji,jj) =   sf_river(jr_dsi)%fnow(ji,jj,1)  &
+                     &              * 1.E3        / ( 28.1 * zcoef + rtrn )
+                  rivdoc(ji,jj) =   sf_river(jr_doc)%fnow(ji,jj,1)  &
+                     &              * 1.E3        / ( 12. * zcoef + rtrn ) 
+               END_2D
             ELSE    !  ln_p5z
-               DO jj = 1, jpj
-                  DO ji = 1, jpi
-                     zcoef = ryyss * e1e2t(ji,jj) * h_rnf(ji,jj) 
-                     rivalk(ji,jj) =   sf_river(jr_dic)%fnow(ji,jj,1)                                    &
-                        &              * 1.E3        / ( 12. * zcoef + rtrn )
-                     rivdic(ji,jj) = ( sf_river(jr_dic)%fnow(ji,jj,1) ) &
-                        &              * 1.E3 / ( 12. * zcoef + rtrn ) * tmask(ji,jj,1)
-                     rivdin(ji,jj) = ( sf_river(jr_din)%fnow(ji,jj,1) ) &
-                        &              * 1.E3 / rno3 / ( 14. * zcoef + rtrn ) * tmask(ji,jj,1)
-                     rivdip(ji,jj) = ( sf_river(jr_dip)%fnow(ji,jj,1) ) &
-                        &              * 1.E3 / po4r / ( 31. * zcoef + rtrn ) * tmask(ji,jj,1)
-                     rivdon(ji,jj) = ( sf_river(jr_don)%fnow(ji,jj,1) ) &
-                        &              * 1.E3 / rno3 / ( 14. * zcoef + rtrn ) * tmask(ji,jj,1)
-                     rivdop(ji,jj) = ( sf_river(jr_dop)%fnow(ji,jj,1) ) &
-                        &              * 1.E3 / po4r / ( 31. * zcoef + rtrn ) * tmask(ji,jj,1)
-                     rivdsi(ji,jj) =   sf_river(jr_dsi)%fnow(ji,jj,1)  &
-                        &              * 1.E3        / ( 28.1 * zcoef + rtrn )
-                     rivdoc(ji,jj) =   sf_river(jr_doc)%fnow(ji,jj,1)  &
-                        &              * 1.E3        / ( 12. * zcoef + rtrn )
-                  END DO
-               END DO
+               DO_2D_11_11
+                  zcoef = ryyss * e1e2t(ji,jj) * h_rnf(ji,jj) 
+                  rivalk(ji,jj) =   sf_river(jr_dic)%fnow(ji,jj,1)                                    &
+                     &              * 1.E3        / ( 12. * zcoef + rtrn )
+                  rivdic(ji,jj) = ( sf_river(jr_dic)%fnow(ji,jj,1) ) &
+                     &              * 1.E3 / ( 12. * zcoef + rtrn ) * tmask(ji,jj,1)
+                  rivdin(ji,jj) = ( sf_river(jr_din)%fnow(ji,jj,1) ) &
+                     &              * 1.E3 / rno3 / ( 14. * zcoef + rtrn ) * tmask(ji,jj,1)
+                  rivdip(ji,jj) = ( sf_river(jr_dip)%fnow(ji,jj,1) ) &
+                     &              * 1.E3 / po4r / ( 31. * zcoef + rtrn ) * tmask(ji,jj,1)
+                  rivdon(ji,jj) = ( sf_river(jr_don)%fnow(ji,jj,1) ) &
+                     &              * 1.E3 / rno3 / ( 14. * zcoef + rtrn ) * tmask(ji,jj,1)
+                  rivdop(ji,jj) = ( sf_river(jr_dop)%fnow(ji,jj,1) ) &
+                     &              * 1.E3 / po4r / ( 31. * zcoef + rtrn ) * tmask(ji,jj,1)
+                  rivdsi(ji,jj) =   sf_river(jr_dsi)%fnow(ji,jj,1)  &
+                     &              * 1.E3        / ( 28.1 * zcoef + rtrn )
+                  rivdoc(ji,jj) =   sf_river(jr_doc)%fnow(ji,jj,1)  &
+                     &              * 1.E3        / ( 12. * zcoef + rtrn )
+               END_2D
             ENDIF
          ENDIF
@@ -411,33 +407,25 @@
          IF(lwp) WRITE(numout,*)
          IF(lwp) WRITE(numout,*) ' Level corresponding to 50m depth ',  ik50,' ', gdept_1d(ik50+1)
-         DO jk = 1, ik50
-            DO jj = 2, jpjm1
-               DO ji = fs_2, fs_jpim1
-                  ze3t   = e3t_0(ji,jj,jk)
-                  zsurfc =  e1u(ji,jj) * ( 1. - umask(ji  ,jj  ,jk) )   &
-                          + e1u(ji,jj) * ( 1. - umask(ji-1,jj  ,jk) )   &
-                          + e2v(ji,jj) * ( 1. - vmask(ji  ,jj  ,jk) )   &
-                          + e2v(ji,jj) * ( 1. - vmask(ji  ,jj-1,jk) )
-                  zsurfp = zsurfc * ze3t / e1e2t(ji,jj)
-                  ! estimation of the coastal slope : 5 km off the coast
-                  ze3t2 = ze3t * ze3t
-                  zcslp = SQRT( ( distcoast*distcoast + ze3t2 ) / ze3t2 )
-                  !
-                  zcmask(ji,jj,jk) = zcmask(ji,jj,jk) + zcslp * zsurfp
-               END DO
-            END DO
-         END DO
+         DO_3D_00_00( 1, ik50 )
+            ze3t   = e3t_0(ji,jj,jk)
+            zsurfc =  e1u(ji,jj) * ( 1. - umask(ji  ,jj  ,jk) )   &
+                    + e1u(ji,jj) * ( 1. - umask(ji-1,jj  ,jk) )   &
+                    + e2v(ji,jj) * ( 1. - vmask(ji  ,jj  ,jk) )   &
+                    + e2v(ji,jj) * ( 1. - vmask(ji  ,jj-1,jk) )
+            zsurfp = zsurfc * ze3t / e1e2t(ji,jj)
+            ! estimation of the coastal slope : 5 km off the coast
+            ze3t2 = ze3t * ze3t
+            zcslp = SQRT( ( distcoast*distcoast + ze3t2 ) / ze3t2 )
+            !
+            zcmask(ji,jj,jk) = zcmask(ji,jj,jk) + zcslp * zsurfp
+         END_3D
          !
          CALL lbc_lnk( 'p4zsbc', zcmask , 'T', 1. )      ! lateral boundary conditions on cmask   (sign unchanged)
          !
-         DO jk = 1, jpk
-            DO jj = 1, jpj
-               DO ji = 1, jpi
-                  zexpide   = MIN( 8.,( gdept_n(ji,jj,jk) / 500. )**(-1.5) )
-                  zdenitide = -0.9543 + 0.7662 * LOG( zexpide ) - 0.235 * LOG( zexpide )**2
-                  zcmask(ji,jj,jk) = zcmask(ji,jj,jk) * MIN( 1., EXP( zdenitide ) / 0.5 )
-               END DO
-            END DO
-         END DO
+         DO_3D_11_11( 1, jpk )
+            zexpide   = MIN( 8.,( gdept_n(ji,jj,jk) / 500. )**(-1.5) )
+            zdenitide = -0.9543 + 0.7662 * LOG( zexpide ) - 0.235 * LOG( zexpide )**2
+            zcmask(ji,jj,jk) = zcmask(ji,jj,jk) * MIN( 1., EXP( zdenitide ) / 0.5 )
+         END_3D
          ! Coastal supply of iron
          ! -------------------------
Index: /NEMO/branches/2020/temporary_r4_trunk/src/TOP/PISCES/P4Z/p4zsms.F90
===================================================================
--- /NEMO/branches/2020/temporary_r4_trunk/src/TOP/PISCES/P4Z/p4zsms.F90	(revision 13468)
+++ /NEMO/branches/2020/temporary_r4_trunk/src/TOP/PISCES/P4Z/p4zsms.F90	(revision 13469)
@@ -127,14 +127,10 @@
          xnegtr(:,:,:) = 1.e0
          DO jn = jp_pcs0, jp_pcs1
-            DO jk = 1, jpk
-               DO jj = 1, jpj
-                  DO ji = 1, jpi
-                     IF( ( trb(ji,jj,jk,jn) + tra(ji,jj,jk,jn) ) < 0.e0 ) THEN
-                        ztra             = ABS( trb(ji,jj,jk,jn) ) / ( ABS( tra(ji,jj,jk,jn) ) + rtrn )
-                        xnegtr(ji,jj,jk) = MIN( xnegtr(ji,jj,jk),  ztra )
-                     ENDIF
-                 END DO
-               END DO
-            END DO
+            DO_3D_11_11( 1, jpk )
+               IF( ( trb(ji,jj,jk,jn) + tra(ji,jj,jk,jn) ) < 0.e0 ) THEN
+                  ztra             = ABS( trb(ji,jj,jk,jn) ) / ( ABS( tra(ji,jj,jk,jn) ) + rtrn )
+                  xnegtr(ji,jj,jk) = MIN( xnegtr(ji,jj,jk),  ztra )
+               ENDIF
+            END_3D
          END DO
          !                                ! where at least 1 tracer concentration becomes negative
